/* util.h - Miscellaneous helper functions

   Copyright (c) 2010-2011 Jukka Lehtosalo

   Alore is licensed under the terms of the MIT license.  See the file
   LICENSE.txt in the distribution.
*/

#ifndef UTIL_H_INCL
#define UTIL_H_INCL

#include <stdarg.h>
#include "thread.h"


typedef enum {
    A_MVT_INT,
    A_MVT_FLOAT,
    A_MVT_STR,
    A_MVT_WIDE_STR,
    A_MVT_OPT_STR,
    A_MVT_LAST_ARG = -1
} AMixedCValueType;


typedef union {
    int intValue;
    double floatValue;
    const char *strValue;
    const AWideChar *wideStrValue;
} AMixedCValue;


typedef AValue (*AOsServiceFunction)(AThread *t,
                                   const AMixedCValue *args);


AValue ACallOsService(AThread *t, AValue *args,
                    const AMixedCValueType *argTypes, AOsServiceFunction func);


AValue ARaiseInternalError(void);


A_APIFUNC int AFormatMessage(char *msg, int maxLen, const char *fmt, ...);
A_APIFUNC int AFormatMessageVa(char *msg, int maxLen, const char *fmt,
                              va_list args);


int AEndsWith(const char *str, const char *prefix);

#ifndef A_HAVE_WINDOWS
#define APathEndsWith AEndsWith
#else
int APathEndsWith(const char *str, const char *prefix);
#endif


#endif
